package com.fwk.actions;


import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.fwk.config.actions.ActionConfig;
import com.fwk.forms.FormBean;
import com.fwk.forms.FormErrors;

/**
 * Classe que representa una acci.
 * @author fjbravo
 *
 */
public abstract class Action {

	/**
	 * Mtode que han d'implementar totes les accions configurades per l'usuari
	 * @param config
	 * @param form
	 * @param req
	 * @param res
	 * @return
	 */
	public abstract ActionForward execute (ActionConfig config, FormBean form, HttpServletRequest req, HttpServletResponse res) throws Exception;
	
	/**
	 * Mtode que poden utilitzar les accions per a guardar errors en la request.
	 * @param req
	 * @param errors
	 */
	public void saveErrors(HttpServletRequest req, FormErrors errors){
		if(req != null && errors != null)
			req.setAttribute("actionFormErrors", errors);
	}
	
	
}
