package com.fwk.actions;

import java.lang.reflect.Method;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.fwk.config.actions.ActionConfig;
import com.fwk.forms.FormBean;

/**
 * Classe que representa una acci que rep per parmetre el mtode que ha
 * d'executar
 * 
 * @author fjbravo
 * 
 */
public class MethodAction extends Action {

	/**
	 * Mtode heretat de la classe Action i que tota acci del framework ha
	 * d'implementar
	 */
	@Override
	public ActionForward execute(ActionConfig config, FormBean form,
			HttpServletRequest req, HttpServletResponse res) throws Exception {

		// Recuperem el nom del parmetre de la request que tindr el nom del
		// mtode a executar
		String parametre = config.getParametre();
		if (parametre == null || parametre.equals(""))
			return null;
		else {
			// Recuperem el valor del parmetre
			String methodValue = req.getParameter(parametre);
			if (methodValue == null || methodValue.equals(""))
				return null;
			else {
				// Executem el mtode adecuat i retornem el resultat
				Method method = getClass().getMethod(methodValue,
						ActionConfig.class, FormBean.class,
						HttpServletRequest.class, HttpServletResponse.class);
				ActionForward forward = (ActionForward) method.invoke(this,
						config, form, req, res);
				return forward;

			}
		}
	}
	

}
