package com.fwk.exceptions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.fwk.actions.ActionForward;
import com.fwk.actions.ActionMessage;
import com.fwk.config.actions.ActionConfig;
import com.fwk.config.exceptions.ExceptionConfig;
import com.fwk.forms.FormBean;
import com.fwk.forms.FormErrors;

/**
 * Definim un manegador d'excepcions per defecte. En cas que no sigui informat cap 
 * handler per a tractar l'excepci, aquest ser qui la tracti
 * @author fjbravo
 *
 */
public class DefaultExceptionHandler extends ExceptionHandler {

	/**
	 * Implementaci del tractament de les excepcions per defecte
	 */
	@Override
	public ActionForward execute(Exception e, ExceptionConfig ec,
			ActionConfig config, FormBean form, HttpServletRequest req,
			HttpServletResponse res) {

		String msg = ec.getKey();
		FormErrors fe = new FormErrors();
		fe.addError("exception", new ActionMessage(msg));
		saveErrors(req, fe);
		
		return config.findForward("error");
		
	}

}
