package com.fwk.exceptions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.fwk.actions.ActionForward;
import com.fwk.config.actions.ActionConfig;
import com.fwk.config.exceptions.ExceptionConfig;
import com.fwk.forms.FormBean;
import com.fwk.forms.FormErrors;

/**
 * Manegador d'excepcions que defineix els mtodes que s'han d'implementar
 * @author fjbravo
 *
 */
public abstract class ExceptionHandler {

	/**
	 * Mtode per defecte que han d'implementar totes les classes que hereten de ExceptionHandler
	 * @param e
	 * @param ec
	 * @param config
	 * @param form
	 * @param req
	 * @param res
	 * @return
	 */
	public abstract ActionForward execute(Exception e, ExceptionConfig ec, ActionConfig config,
			FormBean form, HttpServletRequest req, HttpServletResponse res);
	
	/**
	 * Mtode que poden utilitzar les accions per a guardar errors en la request.
	 * @param req
	 * @param errors
	 */
	public void saveErrors(HttpServletRequest req, FormErrors errors){
		if(req != null && errors != null)
			req.setAttribute("actionFormErrors", errors);
	}
		

}
