package com.fwk.forms;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import com.fwk.actions.ActionMessage;
/**
 * Classe que representa el conjunt de missatges d'error associats a
 * un formulari Web
 * @author fjbravo
 *
 */
public class FormErrors implements Iterable<ActionMessage> {

	//Conjunt d'errors representats per un Map
	private Map<String, ActionMessage> formErrors;
	
	//Constructor
	public FormErrors(){
		this.formErrors = new HashMap<String, ActionMessage>();
	}
	
	/**
	 * Serveix per afegir un missatge d'error
	 * @param key
	 * @param msg
	 */
	public void addError(String key, ActionMessage msg){
		this.formErrors.put(key, msg);
	}
	
	/**
	 * Serveix per a obtenir un missatge d'error identificat per la key
	 * @param key
	 * @return
	 */
	public ActionMessage getError(String key){
		return this.formErrors.get(key);
	}
	
	/**
	 * Retorna true si no ha hagut cap error
	 * @return
	 */
	public boolean isEmpty(){
		return this.formErrors.isEmpty();
	}

	@Override
	public Iterator<ActionMessage> iterator() {
		if(formErrors != null)
			return formErrors.values().iterator();
		return null;
	}
	
}
