package com.fwk.i18;

import java.util.Locale;
import java.util.ResourceBundle;

/**
 * Classe utilitzada per a llegir properties en diferents idiomes 
 * @author fjbravo
 *
 */
public class MessageResourcesReader {
	
	private String urlBase;
	
	private ClassLoader classLoader;
	
	/**
	 * CONSTRUCTOR
	 * @param urlBase
	 * @param classLoader
	 */
	public MessageResourcesReader(String urlBase, ClassLoader classLoader){
		this.urlBase = urlBase.replace(".", "/");
		this.classLoader = classLoader;
	}
	
	/**
	 * Retorna el valor d'una propietat en funci del locale i del classLoader
	 * @param key
	 * @param locale
	 * @return
	 */
	public String getProperty(String key, Locale locale){
		String value = "";
		ResourceBundle resource = ResourceBundle.getBundle(urlBase, locale, getClassLoader());
		value = resource.getString(key);
		return value;
	}

	
	
	//GETTERS I SETTERS
	
	public String getUrlBase() {
		return urlBase;
	}

	public void setUrlBase(String urlBase) {
		this.urlBase = urlBase.replace(".", "/");
	}

	public ClassLoader getClassLoader() {
		return classLoader;
	}

	public void setClassLoader(ClassLoader classLoader) {
		this.classLoader = classLoader;
	}
	
	
}
