package com.fwk.taglibs;

import java.util.ArrayList;
import java.util.Locale;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;

import com.fwk.constants.GlobalConstants;
import com.fwk.i18.MessageResourcesReader;

public class ColumnTag<T extends Object> extends TagSupport {

	/**
	 * 
	 */
	private static final long serialVersionUID = 6111208581581341099L;

	// Clau del missatge que s'ha de mostrar
	private String titleKey;

	// Propietat del bean
	private String property;

	@SuppressWarnings("all")
	@Override
	public int doEndTag() throws JspException {

		ValueListTag<T> valueList = (ValueListTag<T>) this.getParent();
		JspWriter writter = pageContext.getOut();

		Locale sessionLocale = (Locale) pageContext.getSession().getAttribute(
				GlobalConstants.GLOBAL_LOCALE);
		Locale currentLocale = (sessionLocale != null) ? sessionLocale : Locale
				.getDefault();
		String urlBase = (String) pageContext.getServletConfig()
				.getServletContext().getAttribute(
						GlobalConstants.GLOBAL_PROPERTIES_LOCATION);
		MessageResourcesReader msgReader = new MessageResourcesReader(urlBase,
				this.getClass().getClassLoader());
		
		//Guardarem la columna que s'ha de mostrar i el seu ttol
		if(valueList.getColumnTitles() == null)
			valueList.setColumnTitles(new ArrayList<String>());
		if(valueList.getPropertyNames() == null)
			valueList.setPropertyNames(new ArrayList<String>());
		
		valueList.getColumnTitles().add(msgReader.getProperty(titleKey, currentLocale));
		valueList.getPropertyNames().add(property);
		

		return EVAL_PAGE;
	}

	// GETTERS AND SETTERS
	public String getTitleKey() {
		return titleKey;
	}

	public void setTitleKey(String titleKey) {
		this.titleKey = titleKey;
	}

	public String getProperty() {
		return property;
	}

	public void setProperty(String property) {
		this.property = property;
	}
}
