package com.fwk.taglibs;
import java.util.Locale;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.TagSupport;

import com.fwk.actions.ActionMessage;
import com.fwk.constants.GlobalConstants;
import com.fwk.forms.FormErrors;
import com.fwk.i18.MessageResourcesReader;

public class ErrorTag extends TagSupport {
	/**
	 * Default Serial ID
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * Nom que hem de buscar a la request
	 */
	protected String paramName = "actionFormErrors";
	
	protected String style = " ";

	@Override
	public int doEndTag() throws JspException {
		try {
			if (getParamName() != null) {
				FormErrors errors = (FormErrors) pageContext.getAttribute(getParamName(), PageContext.REQUEST_SCOPE);
				if (errors != null) {
					// Inicialitzacions
					Locale sessionLocale = (Locale) pageContext.getSession()
							.getAttribute(GlobalConstants.GLOBAL_LOCALE);
					Locale currentLocale = (sessionLocale != null) ? sessionLocale
							: Locale.getDefault();

					if (!errors.isEmpty()) {
						String urlBase = (String)pageContext.getServletConfig().getServletContext().getAttribute(GlobalConstants.GLOBAL_PROPERTIES_LOCATION);
						MessageResourcesReader msgReader = new MessageResourcesReader(urlBase, this.getClass().getClassLoader());
						JspWriter writter = pageContext.getOut();
						writter.write("<div id=\"errorsDiv\" class=\""+ getStyle() + "\"> <ul>");

						for (ActionMessage msg : errors) {
							writter.write("<li> " + msgReader.getProperty(msg.getKey(),currentLocale) + "</li>");
						}
						writter.write("</ul>" + "</div>");
					}

				}
			}
		} catch (Exception e) {
			throw new JspException(e.toString());
		}
		return EVAL_PAGE;
	}

	
	//GETTERS AND SETTERS
	public String getParamName() {
		return paramName;
	}

	public void setParamName(String paramName) {
		this.paramName = paramName;
	}

	public String getStyle() {
		return style;
	}

	public void setStyle(String style) {
		this.style = style;
	}

}
