package com.fwk.taglibs;

import java.io.IOException;
import java.util.Locale;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;

import com.fwk.constants.GlobalConstants;
import com.fwk.i18.MessageResourcesReader;

/**
 * Etiqueta que mostra un missatge fent servir el sistema d'internacionalitzaci
 * @author fjbravo
 *
 */
public class MessageTag extends TagSupport{
	/**
	 * Generated SerialVersionUID
	 */
	private static final long serialVersionUID = -3446863741110446666L;
	
	//Clau del missatge que volem mostrar
	private String key;
	
	
	@Override
	public int doEndTag() throws JspException {
		// Inicialitzacions
		Locale sessionLocale = (Locale) pageContext.getSession()
				.getAttribute(GlobalConstants.GLOBAL_LOCALE);
		Locale currentLocale = (sessionLocale != null) ? sessionLocale
				: Locale.getDefault();
		String urlBase = (String)pageContext.getServletConfig().getServletContext().getAttribute(GlobalConstants.GLOBAL_PROPERTIES_LOCATION);
		
		MessageResourcesReader msgReader = new MessageResourcesReader(urlBase, this.getClass().getClassLoader());
		JspWriter writter = pageContext.getOut();
		
		try {
			writter.write(msgReader.getProperty(key, currentLocale));
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		return EVAL_PAGE;
	}


	public String getKey() {
		return key;
	}


	public void setKey(String key) {
		this.key = key;
	}
	
	

}
