package com.fwk.taglibs;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.TagSupport;

/**
 * Tag per a mostrar un input Text de forma ms cmoda
 * 
 * @author fjbravo
 * 
 */
public class TextTag extends TagSupport {

	private static final long serialVersionUID = -6997830577493447201L;

	// Nom del bean que es mostrara
	private String beanName;

	// Propietat del bean que es vol mostrar
	private String property;

	// request, session
	private String scope;
	
	// Classe 
	private String styleClass;
	
	//ReadOnly
	private String readOnly;

	@Override
	@SuppressWarnings("all")
	public int doEndTag() throws JspException {
		Object bean = null;
		if (scope != null && !scope.equals("")) {
			if (scope.equals("request"))
				bean = pageContext.getAttribute(beanName,
						PageContext.REQUEST_SCOPE);
			else if (scope.equals("session"))
				bean = pageContext.getAttribute(beanName,
						PageContext.SESSION_SCOPE);
		} else
			bean = pageContext
					.getAttribute(beanName, PageContext.REQUEST_SCOPE);

		String methodName = "get"
				+ String.valueOf(property.charAt(0)).toUpperCase()
				+ property.subSequence(1, property.length());
		Method m;
		try {
			JspWriter writter = pageContext.getOut();
			if (bean != null) {
				m = bean.getClass().getMethod(methodName, null);
				Object result =  m.invoke(bean);
				result = (result != null) ? result.toString() : "";
				if(readOnly != null)
					writter.write("<input type=\"text\" readonly=true value=\"" + result
						+ "\" class=\"" + styleClass +  "\"name=\"" + property + "\"/>");
				else
					writter.write("<input type=\"text\" value=\"" + result
							+ "\" class=\"" + styleClass +  "\"name=\"" + property + "\"/>");
			}
			else{
				if(readOnly != null)
					writter.write("<input type=\"text\" readonly=true value=\"" + ""
						+ "\" class=\"" + styleClass +  "\"name=\"" + property + "\"/>");
				else
					writter.write("<input type=\"text\" value=\"" + ""
							+ "\" class=\"" + styleClass +  "\"name=\"" + property + "\"/>");
			}

		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

		return EVAL_PAGE;
	}

	// GETTERS AND SETTERS
	public String getBeanName() {
		return beanName;
	}

	public void setBeanName(String beanName) {
		this.beanName = beanName;
	}

	public String getProperty() {
		return property;
	}

	public void setProperty(String property) {
		this.property = property;
	}

	public String getStyleClass() {
		return styleClass;
	}

	public void setStyleClass(String styleClass) {
		this.styleClass = styleClass;
	}

	public String getScope() {
		return scope;
	}

	public void setScope(String scope) {
		this.scope = scope;
	}

	public String getReadOnly() {
		return readOnly;
	}

	public void setReadOnly(String readOnly) {
		this.readOnly = readOnly;
	}

}
