package com.fwk.taglibs;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.BodyTagSupport;

public class ValueListTag<T extends Object> extends BodyTagSupport {

	/**
	 * Ha de ser serializable
	 */
	private static final long serialVersionUID = 821068966482850703L;

	// LListat d'objectes
	private String list;

	// Llistat que recuperarem de la petici
	private List<T> beansList;

	// Titols de les columnes
	private List<String> columnTitles;

	// Noms de les propietas que han de ser mostrades
	private List<String> propertyNames;

	// Estil que tindr el llistat
	private String style;

	// Imatge
	private String image;

	// Link on ha d'apuntar la imatge
	private String imageLink;

	// Parametres que li passem a la url del link
	private String imageParamProperty;

	@SuppressWarnings("all")
	@Override
	public void doInitBody() {
		setBeansList((List<T>) pageContext.getAttribute(list,
				PageContext.REQUEST_SCOPE));
		columnTitles = new ArrayList<String>();
		propertyNames = new ArrayList<String>();
	}

	@Override
	@SuppressWarnings("all")
	public int doAfterBody() {
		JspWriter out = getBodyContent().getEnclosingWriter();
		setBeansList((List<T>) pageContext.getAttribute(list,
				PageContext.REQUEST_SCOPE));
		try {
			out.write("<table class=\"" + style
					+ "\" border=\"0\" cellspacing=\"0\">");

			// Primer mostrem una fila amb tots els ttols de les columnes
			out.write("<tr  class=\"rowTitle\">");
			boolean done = false;
			for (String title : columnTitles) {

				if (image != null && imageLink != null && !done) {
					out.write("<td colspan=\""
							+ Integer.toString(propertyNames.size()
									+ ((image != null && imageLink != null) ? 1
											: 0))
							+ "\" class=\"rowstyle0\"> <b>");
					out.write("</b></td>");
					done = true;
				}
				out
						.write("<td colspan=\""
								+ Integer
										.toString(propertyNames.size()
												+ ((image != null && imageLink != null) ? 1
														: 0))
								+ "\" class=\"rowstyle0\"> <b>");
				out.write(title);
				out.write("</b></td>");
			}
			out.write("</tr>");

			// A continuaci imprimim fila a fila, tot el contingut del llistat
			boolean par = true;
			for (T bean : beansList) {
				String classNumber = (par) ? "0" : "1";
				out.write("<tr class=\"rowStyle" + classNumber + "\">");

				if (image != null && imageLink != null) {
					out.write("<td colspan=\""
							+ Integer.toString(propertyNames.size() + 1)
							+ "\"  class=\"rowstyle" + classNumber + "\">");

					String methodName = "get"
							+ String.valueOf(imageParamProperty.charAt(0))
									.toUpperCase()
							+ imageParamProperty.subSequence(1,
									imageParamProperty.length());
					Method m = bean.getClass().getMethod(methodName, null);
					String result = "";
					if (m.invoke(bean) != null)
						result = (String) m.invoke(bean).toString();
					out.write("<a href=\"" + imageLink
							+ ((imageLink.endsWith(".do")) ? "?" : "&")
							+ imageParamProperty + "=" + result
							+ "\"> <img src=\"" + image + "\"/></a>");

				}

				for (String property : propertyNames) {
					String methodName = "get"
							+ String.valueOf(property.charAt(0)).toUpperCase()
							+ property.subSequence(1, property.length());
					Method m = bean.getClass().getMethod(methodName, null);
					String result = "";
					if (m.invoke(bean) != null)
						result = (String) m.invoke(bean).toString();

					out.write("<td colspan=\""
							+ Integer.toString(propertyNames.size()
									+ ((image != null && imageLink != null) ? 1
											: 0)) + "\"   class=\"rowstyle"
							+ classNumber + "\">");
					out.write(result);
					out.write("</td>");
				}
				out.write("</tr>");
				if (par)
					par = false;
				else
					par = true;
			}
			out.write("</tr>");
			out.write("</table>");
		} catch (IOException e) {
			e.printStackTrace();
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}
		return EVAL_PAGE;
	}

	// GETTERS AND SETTERS
	public List<T> getBeansList() {
		return beansList;
	}

	public void setBeansList(List<T> beansList) {
		this.beansList = beansList;
	}

	public String getList() {
		return list;
	}

	public void setList(String list) {
		this.list = list;
	}

	public List<String> getColumnTitles() {
		return columnTitles;
	}

	public void setColumnTitles(List<String> columnTitles) {
		this.columnTitles = columnTitles;
	}

	public List<String> getPropertyNames() {
		return propertyNames;
	}

	public void setPropertyNames(List<String> propertyNames) {
		this.propertyNames = propertyNames;
	}

	public String getStyle() {
		return style;
	}

	public void setStyle(String style) {
		this.style = style;
	}

	public String getImageLink() {
		return imageLink;
	}

	public void setImageLink(String imageLink) {
		this.imageLink = imageLink;
	}

	public String getImage() {
		return image;
	}

	public void setImage(String image) {
		this.image = image;
	}

	public String getImageParamProperty() {
		return imageParamProperty;
	}

	public void setImageParamProperty(String imageParamProperty) {
		this.imageParamProperty = imageParamProperty;
	}

}
