package test.accions;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import test.forms.StudentsForm;
import test.model.Alumne;

import com.fwk.actions.ActionForward;
import com.fwk.actions.MethodAction;
import com.fwk.config.actions.ActionConfig;
import com.fwk.forms.FormBean;

/**
 * Operacions relacionades amb entitats alumne
 * @author fjbravo
 *
 */
public class StudentAction extends MethodAction{

	/**
	 * Obtenim un llistat d'estudiants
	 * @param config
	 * @param form
	 * @param req
	 * @param res
	 * @return
	 * @throws Exception
	 */
	@SuppressWarnings("unchecked")
	public ActionForward list(ActionConfig config, FormBean form, HttpServletRequest req, HttpServletResponse res) throws Exception{
		
		List<Alumne> auxList = new ArrayList<Alumne>();

		if(req.getSession().getAttribute("_alumesBD") != null){
				Map<Integer,Alumne> auxMap = (Map<Integer,Alumne>) req.getSession().getAttribute("_alumesBD");
				
				for(Integer i : auxMap.keySet()){
					Alumne a = auxMap.get(i);
					auxList.add(a);
				}
		}
			req.setAttribute("alumnesList", auxList);
		
		return config.findForward("list");
	}
	
	/**
	 * Mostra la pantalla de modificaci
	 * @param config
	 * @param form
	 * @param req
	 * @param res
	 * @return
	 * @throws Exception
	 */
	@SuppressWarnings({"unchecked"})
	public  ActionForward showModify(ActionConfig config, FormBean form, HttpServletRequest req, HttpServletResponse res) throws Exception{
		
		String codiAlumne = req.getParameter("id");
		
		if(codiAlumne != null){
			if(req.getSession().getAttribute("_alumesBD") != null){
				Map<Integer,Alumne> auxMap = (Map<Integer,Alumne>) req.getSession().getAttribute("_alumesBD");
				Integer id = new Integer(codiAlumne);
				Alumne a = auxMap.get(id);
				if(a != null){
					StudentsForm aForm = (StudentsForm) form;
					aForm.setAdreca(a.getAdreca());
					aForm.setCodiPostal(a.getCodiPostal());
					aForm.setCognoms(a.getCognoms());
					aForm.setDni(a.getDni());
					aForm.setEdat(a.getEdat());
					aForm.setId(a.getId());
					aForm.setNom(a.getNom());
					aForm.setTelefon(a.getTelefon());
				}
			}
		}
		
		return config.findForward("showModify");
	}
	
	
	@SuppressWarnings({"unchecked"})
	public  ActionForward save(ActionConfig config, FormBean form, HttpServletRequest req, HttpServletResponse res) throws Exception{

		if(req.getSession().getAttribute("_alumesBD") != null){
			Map<Integer,Alumne> auxMap = (Map<Integer,Alumne>) req.getSession().getAttribute("_alumesBD");
			StudentsForm aForm = (StudentsForm) form;
			Alumne a = auxMap.get(aForm.getId());
			if(a == null){
				a = new Alumne();
			}
				a.setAdreca(aForm.getAdreca());
				if(aForm.getCodiPostal() != null)
					a.setCodiPostal(aForm.getCodiPostal());
				else
					throw new NumberFormatException();
				
				a.setCognoms(aForm.getCognoms());
				a.setDni(aForm.getDni());
				
				if(aForm.getEdat() != null)
					a.setEdat(aForm.getEdat());
				else
					throw new NumberFormatException();
				if(aForm.getId() == null)
					throw new NumberFormatException();
				else	
					a.setId(aForm.getId());
				a.setNom(aForm.getNom());
				a.setTelefon(aForm.getTelefon());
			
				auxMap.put(aForm.getId(), a);
		}
		return(config.findForward("listRedirect"));
		
	}
	
	
	/**
	 * Mostra la vista de creaci
	 * @param config
	 * @param form
	 * @param req
	 * @param res
	 * @return
	 * @throws Exception
	 */
	public  ActionForward showCreate(ActionConfig config, FormBean form, HttpServletRequest req, HttpServletResponse res) throws Exception{
		
		return config.findForward("showCreate");
	}
	
	
	
	@SuppressWarnings({"unchecked"})
	public  ActionForward create(ActionConfig config, FormBean form, HttpServletRequest req, HttpServletResponse res) throws Exception{

		if(req.getSession().getAttribute("_alumesBD") != null){
			Map<Integer,Alumne> auxMap = (Map<Integer,Alumne>) req.getSession().getAttribute("_alumesBD");
			StudentsForm aForm = (StudentsForm) form;
			Alumne	a = new Alumne();
			a.setAdreca(aForm.getAdreca());
				if(aForm.getCodiPostal() != null)
					a.setCodiPostal(aForm.getCodiPostal());
				else
					throw new NullPointerException();
				
				a.setCognoms(aForm.getCognoms());
				a.setDni(aForm.getDni());
				
				if(aForm.getEdat() != null)
					a.setEdat(aForm.getEdat());
				else
					throw new NullPointerException();
				if(aForm.getId() == null)
					throw new NullPointerException();
				else	
					a.setId(aForm.getId());
				a.setNom(aForm.getNom());
				a.setTelefon(aForm.getTelefon());
			
				auxMap.put(aForm.getId(), a);
		}
		return(config.findForward("listRedirect"));
	}
	
	
	@SuppressWarnings({"unchecked"})
	public  ActionForward delete(ActionConfig config, FormBean form, HttpServletRequest req, HttpServletResponse res) throws Exception{
		if(req.getSession().getAttribute("_alumesBD") != null){
			Map<Integer,Alumne> auxMap = (Map<Integer,Alumne>) req.getSession().getAttribute("_alumesBD");
			StudentsForm aForm = (StudentsForm) form;
			Alumne a = auxMap.get(aForm.getId());
			if(a != null){
				auxMap.remove(a.getId());
				req.getSession().setAttribute("_alumesBD", auxMap);
			}
		}
		return(config.findForward("listRedirect"));
		
	}
	
}
